import { CosmWasmClient } from "@cosmjs/cosmwasm-stargate";
import { Network, ChainAddress, TokenBridge, TxHash, TokenId, TokenTransferTransaction, NativeAddress, ChainsConfig, Contracts } from "@wormhole-foundation/connect-sdk";
import { CosmwasmUnsignedTransaction, AnyCosmwasmAddress, CosmwasmChainName, CosmwasmPlatform } from "@wormhole-foundation/connect-sdk-cosmwasm";
export declare class CosmwasmTokenBridge implements TokenBridge<"Cosmwasm"> {
    readonly network: Network;
    readonly chain: CosmwasmChainName;
    readonly rpc: CosmWasmClient;
    readonly contracts: Contracts;
    private tokenBridge;
    private translator?;
    private constructor();
    static fromRpc(rpc: CosmWasmClient, config: ChainsConfig): Promise<CosmwasmTokenBridge>;
    isWrappedAsset(token: AnyCosmwasmAddress): Promise<boolean>;
    hasWrappedAsset(token: TokenId): Promise<boolean>;
    getWrappedAsset(token: TokenId): Promise<NativeAddress<CosmwasmPlatform.Type>>;
    getOriginalAsset(token: AnyCosmwasmAddress): Promise<TokenId>;
    isTransferCompleted(vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">): Promise<boolean>;
    createAttestation(token: AnyCosmwasmAddress | "native", payer?: AnyCosmwasmAddress): AsyncGenerator<CosmwasmUnsignedTransaction>;
    submitAttestation(vaa: TokenBridge.VAA<"AttestMeta">, payer?: AnyCosmwasmAddress): AsyncGenerator<CosmwasmUnsignedTransaction>;
    transfer(sender: AnyCosmwasmAddress, recipient: ChainAddress, token: AnyCosmwasmAddress | "native", amount: bigint, payload?: Uint8Array): AsyncGenerator<CosmwasmUnsignedTransaction>;
    redeem(sender: AnyCosmwasmAddress, vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">, unwrapNative?: boolean): AsyncGenerator<CosmwasmUnsignedTransaction>;
    parseTransactionDetails(txid: TxHash): Promise<TokenTransferTransaction[]>;
    getWrappedNative(): Promise<NativeAddress<CosmwasmPlatform.Type>>;
    private createUnsignedTx;
}
//# sourceMappingURL=tokenBridge.d.ts.map